<?php
include('includes/application_top.php');
require(DIR_WS_INCLUDES . 'database_tables.php');

// FUNZIONI UTILI
if (!function_exists('html_entity_decode')) {
 function html_entity_decode ($string, $opt = ENT_COMPAT) {
   $trans_tbl = get_html_translation_table (HTML_ENTITIES);
   $trans_tbl = array_flip ($trans_tbl);
   if ($opt & 1) { // Translating single quotes
     // Add single quote to translation table; doesn't appear to be there by default
     $trans_tbl["&apos;"] = "'";
   }
   if (!($opt & 2)) { // Not translating double quotes
     // Remove double quote from translation table
     unset($trans_tbl["&quot;"]);
   }
   return strtr ($string, $trans_tbl); 
 }
}

if (!defined("ENT_COMPAT")) define("ENT_COMPAT", 2);
if (!defined("ENT_NOQUOTES")) define("ENT_NOQUOTES", 0);
if (!defined("ENT_QUOTES")) define("ENT_QUOTES", 3);

function clean_html_kelkoo($description, $length=1024) {
  global $its_cleaned;
  $its_cleaned = html_entity_decode ($description);
  $its_cleaned = strip_tags ($description);
  $its_cleaned = strtolower ($its_cleaned);
  $its_cleaned = str_replace(chr(9)," ",$its_cleaned);  //$its_cleaned = str_replace("t","",$its_cleaned);
  $its_cleaned = str_replace(chr(10)," ",$its_cleaned);//$its_cleaned = str_replace("n","",$its_cleaned);
  $its_cleaned = str_replace(chr(13)," ",$its_cleaned);//$its_cleaned = str_replace("r","",$its_cleaned);
  $its_cleaned = str_replace("&nbsp;"," ",$its_cleaned);
  $its_cleaned = preg_replace("[<(.*?)>]"," ",$its_cleaned);
  $its_cleaned = preg_replace("/\s+/"," ",$its_cleaned);
  $its_cleaned = stripslashes($its_cleaned);
  $its_cleaned = trim ($its_cleaned);
  if (strlen($its_cleaned) > $length) {
    $its_cleaned = substr($its_cleaned, 0, $length-3);
    $its_cleaned .= '...';
  }
  return $its_cleaned;
}  

function getCategories($id) {
  global $listacat,$categorie;
  $categorie = $listacat[$id]["nome"]."#".$categorie;
  if ($listacat[$id]["parentid"] != 0) {getCategories($listacat[$id]["parentid"]);}
}  

// SHOW INFO
if (isset($_GET["get_info"])) {
	phpinfo();
	die();
}

// NOME SITO! IMPORTANTE: SENZA SLASH FINALE!
if (isset($_GET["site_url"])) {
	$site_url = "http://".$_GET["site_url"];
} else {
	$site_url = "http://".$_SERVER["HTTP_HOST"];
}
$tt = preg_match("/(.*)(\[^\]+$)/",$_SERVER["PHP_SELF"],$path_name);
$site_url .= $path_name[1];

// ID DELLA LINGUA
$language_id = 0;
$language_code = "";

$mysqli = new mysqli(DB_SERVER, DB_SERVER_USERNAME, DB_SERVER_PASSWORD, DB_DATABASE);

if ($mysqli->connect_errno) {
    echo "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
}

if (isset($_GET["show_languages"])) {
	$result = $mysqli->query("SELECT * FROM languages");
	if ($row = mysqli_fetch_array($result)) {
		do {
			echo $row["languages_id"]. " - " . $row["name"] . " (".$row["code"].")\n<br>";
		} while($row = mysqli_fetch_array($result));
	}
	die();
} else  if (isset($_GET["language_id"]) && $_GET["language_id"] != "") {
	$language_id = $_GET["language_id"];
} else {
	$result = $mysqli->query("SELECT * FROM languages");
	if ($row = mysqli_fetch_array($result)) {
		do {
			if (preg_match("/(^En|^en)/", $row["name"])) {$language_id = $row["languages_id"];}
		} while($row = mysqli_fetch_array($result));
	}
}
if ($language_id==0) {
	die("Language ID not found");
} else {
	$resultL = $mysqli->query("SELECT code FROM languages WHERE languages_id = '$language_id'");
	$rowL = mysqli_fetch_array($resultL);
	$language_code = $rowL["code"];
}


// QUERY LISTA CATEGORIE
$resultcat = $mysqli->query("SELECT c.categories_id,c.parent_id,cd.categories_name FROM " . TABLE_CATEGORIES . "  AS c LEFT JOIN " . TABLE_CATEGORIES_DESCRIPTION . " AS cd ON c.categories_id = cd.categories_id WHERE language_id = $language_id");
if ($row = mysqli_fetch_array($resultcat)) {
	do {
		$listacat[$row["categories_id"]]["nome"] = $row["categories_name"];
		$listacat[$row["categories_id"]]["parentid"] = $row["parent_id"];
	} while($row = mysqli_fetch_array($resultcat));
}

//echo "<pre>\n";
//print_r($listacat);
//echo "</pre>\n";

// QUERY 
$query_sql = "SELECT count(*) FROM " . TABLE_PRODUCTS . " AS p LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " AS pd ON p.products_id = pd.products_id LEFT JOIN " . TABLE_PRODUCTS_TO_CATEGORIES . " AS p2c ON p.products_id = p2c.products_id LEFT JOIN " . TABLE_MANUFACTURERS . " AS m ON m.manufacturers_id = p.manufacturers_id LEFT JOIN " . TABLE_SPECIALS . " AS s on p.products_id = s.products_id LEFT JOIN tax_rates AS t on t.tax_class_id = p.products_tax_class_id WHERE p.products_id = pd.products_id AND p.products_id = p2c.products_id AND p.products_status = '1' AND pd.language_id = '" . $language_id;
$query_sql = "SELECT p.products_id, p2c.categories_id, m.manufacturers_name, pd.products_name, pd.products_description, p.products_quantity, p.products_image, p.products_tax_class_id, t.tax_rate, IF(s.status, s.specials_new_products_price, NULL) as specials_new_products_price, IF(s.status, s.specials_new_products_price, p.products_price) AS final_price FROM " . TABLE_PRODUCTS . " AS p LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " AS pd ON p.products_id = pd.products_id LEFT JOIN " . TABLE_PRODUCTS_TO_CATEGORIES . " AS p2c ON p.products_id = p2c.products_id LEFT JOIN " . TABLE_MANUFACTURERS . " AS m ON m.manufacturers_id = p.manufacturers_id LEFT JOIN " . TABLE_SPECIALS . " AS s on p.products_id = s.products_id LEFT JOIN tax_rates AS t on t.tax_class_id = p.products_tax_class_id WHERE p.products_id = pd.products_id AND p.products_id = p2c.products_id AND p.products_status = '1' AND pd.language_id = '" . $language_id . "' GROUP BY p.products_id ORDER BY p2c.categories_id, pd.products_name";

$result = $mysqli->query( $query_sql );
$numrows = mysqli_num_rows( $result );


if ($row = mysqli_fetch_array($result)) {
	do	{
		// Categorie
		$categorie = "";
		getCategories($row["categories_id"]);
		$categorie = preg_replace("(^#+)","",$categorie);
		$categorie = preg_replace("(#+$)","",$categorie);
		$tax = 1+((($row["tax_rate"] == "") ? 0 : $row["tax_rate"])/100);
	
		$filestring=clean_html_kelkoo($categorie)."|".clean_html_kelkoo($row["manufacturers_name"])."|".clean_html_kelkoo($row["products_name"])."|".clean_html_kelkoo($row["products_description"],300)."|".($row["final_price"]*$tax)."|".$site_url."/product_info.php?products_id=".$row["products_id"]."&language=$language_code&from=kelkoo"."|".$row["products_quantity"]."|".(($row["products_image"] == "") ? "" : $site_url."/images/".str_replace(" ","%20",$row["products_image"]))."|".(($row['specials_new_products_price'] != "") ? "1" : "0")."|<FINERIGA>\n";
	
		$file.=$filestring;
		echo $filestring;
	} while($row = mysqli_fetch_array($result));
}
?>
